﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace NewsTickerSample
{
    public partial class NewsTicker : UserControl
    {
        private string _completeText = string.Empty;
        
        public NewsTicker()
        {
            InitializeComponent();
        }

        public virtual bool Enabled
        {
            get
            {
                return this.timer1.Enabled;
            }
            set
            {
                this.timer1.Enabled = value;
            }
        }

        public virtual int Interval
        {
            get
            {
                return this.timer1.Interval;
            }
            set
            {
                this.timer1.Interval = value;
            }
        }

        public virtual string Text
        {
            get
            {
                return this.label1.Text;
            }
            set
            {
                if (_completeText == string.Empty)
                {
                    _completeText = value;
                }

                this.label1.Text = value;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;

            if (this.Text.Length > 2)
            {
                this.Text = this.Text.Remove(0, 1);

                using (Graphics currentGraphics = this.CreateGraphics())
                {
                    if (currentGraphics.MeasureString(this.Text, this.label1.Font).Width < this.Width)
                    {
                        this.Text += " " + _completeText;
                        this.Text = this.Text.Remove(0, 1);
                    }
                }
            }

            timer1.Enabled = true;
        }
    }
}
